SEM_WAIT(3) | Library Functions Manual | SEM_WAIT(3)

# NAME

`sem_wait`, `sem_timedwait`, `sem_trywait` — decrement (lock) a semaphore

# LIBRARY

POSIX Real-time Library (librt, -lrt)

# SYNOPSIS

`#include <semaphore.h>`

int
`sem_wait`(sem_t *sem);

int
`sem_timedwait`(sem_t *sem, const struct timespec * restrict abstime);

int
`sem_trywait`(sem_t *sem);

# DESCRIPTION

The `sem_wait`() function decrements (locks) the semaphore pointed to by sem, but blocks if the value of sem is zero, until the value is non-zero and the value can be decremented.

The `sem_timedwait`() function performs the same action, but will not wait beyond abstime for the value of sem to be non-zero.

The `sem_trywait`() function decrements (locks) the semaphore pointed to by sem only if the value is non-zero. Otherwise, the semaphore is not decremented and an error is returned.

# RETURN VALUES

The `sem_wait`() function returns the value 0 if successful; otherwise the value -1 is returned and the global variable errno is set to indicate the error.

# ERRORS

`sem_wait`(), `sem_timedwait`(), and `sem_trywait`() will fail if:

[`EINVAL`]
  sem points to an invalid semaphore.

Additionally, `sem_trywait`() will fail if:

[`EAGAIN`]
  The semaphore value was zero, and thus could not be decremented.

`sem_timedwait`() will also fail if:

[`ETIMEDOUT`]
  The semaphore value was zero and abstime was reached.

# SEE ALSO

sem_post(3)

# STANDARDS

`sem_wait`() and `sem_trywait`() conform to ISO/IEC 9945-1:1996 (“POSIX.1”).

February 29, 2012 | NetBSD 11.0